;convert.asm

;
;a=byte to be converted, hl=char *out_string
conv_bh:
   push af
   push bc
   push de
   push hl
   ex de,hl
   push af
   ld b,4
cb0:
   srl a
   djnz cb0
   ld c,a
   ld b,0
   ld hl,char_table
   add hl,bc
   ld a,(hl)
   ld (de),a
   inc de
   pop af
   and $F
   ld c,a
   ld b,0
   ld hl,char_table
   add hl,bc
   ld a,(hl)
   ld (de),a
   pop hl
   pop de
   pop bc
   pop af
   ret

;
;hl=char *in_string, de=char *out_string,b=char str_len
conv_ss:
   inc hl
   dec b
   ld a,(hl)
   cp Lquote
   ret z
   ld (de),a
   inc de
   ld a,b
   cp 0
   ret z
   inc c
   jr conv_ss

;
;hl=char *in_string, de=char *out_string,b=char str_len
conv_string:
   ld c,0
cs0:
   ld a,b
   cp 0
   jr nz,cs1
   ld a,c
   ret
cs1: ld a,(hl)
   cp Lquote
   jr nz,cs2
   call conv_ss
   jr cs0
cs2:
   call conv_hs
   jr cs0

;
;hl=char *in_string, de=char *out_string,b=char str_len
conv_hs:
   push de
   ld a,(hl)
   cp Lquote
   jr z,ch9
   call conv_hex_digit
   push bc
   ld b,4
ch0: sla d
   djnz ch0
   pop bc
      ld a,b
      cp 0
      jr z,ch9
      dec b
   inc hl
   ld a,(hl)
   cp Lquote
   jr z,ch9
   call conv_hex_digit
   ld a,d
   pop de
   ld (de),a
   inc hl
   inc de
      dec b
      inc c
      ld a,b
      cp 0
      ret z
   jr conv_hs
ch9: pop de
   ret

;
conv_hex_digit:
;input: digit in a
;output: hex value in low 4 bits of d
   push hl
   push bc
   ld b,16
   ld hl,char_table
chd0:
   cp (hl)
   jr z,chd1
   inc hl
   djnz chd0
   ld hl,char_table
chd1:
   ld bc,-char_table
   add hl,bc
   ld a,d
   and $F0
   or l
   ld d,a
   pop bc
   pop hl
   ret
   
;
char_table:
   .db "0123"
   .db "4567"
   .db "89AB"
   .db "CDEF"
