;mode.asm

;
;mode service routines
;
view:
   ret

edit:
   call set_pages
   ld hl,e_string
   ld de,conv_e_string
   ld a,(cur_str_pos)
   ld b,a
   call conv_string
   ld b,a
   ld de,(cur_offset)
   ld hl,conv_e_string
Ae0:
   ld a,b
   cp 0
   jr nz,Ae1
   call pop_pages
   call show_screen
   ret
Ae1: dec b
   ld a,(hl)
   ld (de),a
   inc hl
   inc de
   jr Ae0

search:
   call set_pages
   ld hl,e_string
   ld de,conv_e_string
   ld a,(cur_str_pos)
   ld b,a
   call conv_string
   ld b,a
   ld (str_len),a
   ld hl,(cur_offset)
   ld (old_offset),hl
   ld de,conv_e_string
s0: ld a,b     ;if end of string, goto s4
   cp 0
   jr z,s4
   ld a,(de)   ;get character from string.
   cp (hl)  ;if it's equal to char at (hl), inc both pointers, and loop.
   jr nz,s2
   inc hl
   inc de
   dec b
   jr s3
s2: ld de,conv_e_string ;if ne to char at (hl), back up mem pointer,
   ld hl,(old_offset)   ;and reset string ptr to start of string.
   inc hl
   ld (old_offset),hl
   ld a,(str_len)
   ld b,a
   
s3: ld a,(cur_offset+1) ;if hl = (cur_offset), then end of loop
   cp h                 ;we didn't find the string.
   jr nz,s0
   ld a,(cur_offset)
   cp l
   jr nz,s0
   call pop_pages
   ret

s4: push hl             ;found it!
   ld hl,conv_e_string    
   ld a,(str_len)
   neg
   ld c,a
   ld b,$FF
   pop hl
   add hl,bc
   ld (cur_offset),hl
   call pop_pages
   call show_screen
   ret
   

;
;mode change routines
;

upd_emode:
   ld a,(emode)
   push ix
      ld ix,emode_tbl
      ld c,a
      ld b,0
      add ix,bc
      add ix,bc
      add ix,bc
      ld a,(ix)
      ld (emode_char),a
      ld l,(ix+1)
      ld h,(ix+2)
      ld (em_char_tbl),hl
   pop ix
   call show_stat_line
   ret

;
show_mode_line:
   ld hl,mode_line_loc
   ld (_curRow),hl
   ld hl,mode_str
   call _puts
   ld a,(mode)
   ld c,a
   ld b,0
   push ix
   ld ix,mode_str_indx
   add ix,bc
   add ix,bc
   ld h,(ix+1)
   ld l,(ix)
   pop ix
   push bc
   call _puts
   pop bc
   push ix
   ld ix,mode_tbl
   add ix,bc
   add ix,bc
   ld h,(ix+1)
   ld l,(ix)
   pop ix
   ld (mode_srvc),hl
   ret
